<?php
	
	require_once('config.php');
	error_reporting(E_CONFIG);


	require_once('functions.php');
	require_once('FileMaker.php');
	require_once('classes.php');

	session_start();
	
	//// login
	if(!isset($_SESSION['user']) and isset($_POST['action'], $_POST['name'], $_POST['password']) and $_POST['action'] == 'login'){
		// save login data

		
		$_SESSION['login']['name'] = $_POST['name'];
		
		// login to ppBaseData (if not already connected)
		if(!isset($ppWeb)) $ppWeb = openDB();

		
		// get user-list	
		$command = $ppWeb->newFindCommand(cEinzelprefs::webLayout);
		$result = $command->execute();
	
		
			if(!FileMaker::IsError($result)){
				$records = $result->getRecords();
				
				foreach($records as $record){
					$sum = new cEinzelprefs($ppWeb, $record); 
					$Auswertung = "";
					$Bueroleiter = $record->getField('f1_Erfassung_UrlaubKrankheit_Bueroleiter_Flag');
					$Erfassung_Mitarbeiter = $record->getField('f1_Erfassung_UrlaubKrankheit_Mitarbeiter_Flag');
					$record->commit();
				}
			}else{
				//die('error: '. $result->getErrorString());
			}
		
		
		//$command = $ppWeb->newFindAllCommand(cUser::webLayout);
		$command = $ppWeb->newFindCommand(cUser::webLayout);
		$command->addFindCriterion('f1_Login_aktiv_flag', '1');
		$command->addFindCriterion('f1_MitarbeiterLizenz_Controlling_Flag', '1');
		$result = $command->execute();
		if(iserror($result)){ header("Location: ./");exit; }
		
		

		$records = $result->getRecords();
		foreach($records as $record) $users[] = new cUser($ppWeb, $record);
		
		foreach($users as $user){
			$tmp_UserPass = hash(HCode, PA_H_1 . $_POST['password'] . PA_H_2 );
			if(strcasecmp($user->Name(), $_POST['name']) == 0 and strcasecmp($user->Password(), $tmp_UserPass) == 0){
				echo $record->getField('user_app_Mitarbeiter::f1_Vertrauensarbeitszeit_Flag');
				$_SESSION['user']['name'] = $user->Name();
				$_SESSION['user']['password'] = $user->Password();
				$_SESSION['user']['user_token'] = $user->User_Token();
				$_SESSION['user']['employee_token'] = $user->Employee_Token();
				$_SESSION['user']['guid'] = $user->GUID();
				$_SESSION['user']['group'] = $user->Group();
				$_SESSION['user']['language'] = $user->Sprache();
				$_SESSION['user']['profitcenter'] = $user->ProfitCenter();
				$_SESSION['user']['flag_NurZE_ProfitCenter'] = $user->Flag_NurZE_ProfitCenter();
				$_SESSION['user']['Auswertung'] = $Auswertung;
				$_SESSION['user']['Bueroleiter'] = $Bueroleiter;
				$_SESSION['user']['Erfassung_Mitarbeiter'] = $Erfassung_Mitarbeiter;
				$_SESSION['user']['Vertrauensarbeitszeit'] = $user->Vertrauensarbeitszeit();
				$_SESSION['user']['LayoutTyp'] = $user->LayoutTyp();
				$_SESSION['user']['ClockTime_ChangeDelete_Record'] = $user->ClockTime_ChangeDelete_Record();
				$_SESSION['user']['ClockTime_Complete_Record'] = $user->ClockTime_Complete_Record();
				break;
			}
		}
		// set memberlist
		$command = $ppWeb->newFindCommand(cMember::webLayout);
        $command->addFindCriterion('f3_Mitarbeiter_aktuell_Flag', '1');
		$command->addSortRule('member_app_Benutzer::f1_Kuerzel', 1, FILEMAKER_SORT_ASCEND);
		$result = $command->execute();

		//print_r ($result);
		
		if(FileMaker::IsError($result)) die("Fehler: Es wurden keine Mitarbeiter angelegt!");

		$members = array();
		$records = $result->getRecords();
		foreach($records as $record) $members[] = new cMember($ppWeb, $record);
		$_SESSION['members'] = array();
		foreach($members as $member) {
			
			$unlockDate = str_replace('/', '.', $member->UnlockDate());
			$distance_from = str_replace('/', '.', $member->distance_from());
			$distance_to = str_replace('/', '.', $member->distance_to());
			
			$_SESSION['members'][] = array(
                    'token' => $member->Token(),
                    'UserKRZ' => $member->UserKRZ(),
					'UserGUID' => $member->UserGUID(),
                    'guid' => $member->GUID(),
                    'lockPast' => $member->LockPast(),
                    //'lockFuture' => $member->LockFuture(),
					'lockFuture' => 0,
                    'unlockDate' => $unlockDate,
                    'activity_begin' => $member->activity_begin(),
                    'activity_end' => $member->activity_end(),
                    'distance_from' => $distance_from,
                    'distance_to' => $distance_to,
					'zhkategorie' => $member->FeeGroup(),
                );
		}
	
                
		foreach($_SESSION['members'] as $member)
			if($_SESSION['user']['employee_token'] == $member['token']){
				$_SESSION['user']['member'] = $member;
			}

                // set Stempeluhr Erfassungsgenauigkeit
			$command = $ppWeb->newFindAllCommand(cEinzelprefs::webLayout);
			$result = $command->execute();
	
			if(FileMaker::IsError($result)) die($result->getErrorString());
	
			$records = $result->getRecords();
			foreach($records as $record) $tests[] = new cEinzelprefs($ppWeb, $record);
	
			foreach($tests as $test){
				$_SESSION['accuracy'] = $test->accuracy();
				break;
			}
			
			if(isset($_SESSION['user'])){
				$files = scandir('tmp/');
				foreach ($files as $file) {
					$stamp = filemtime("tmp/".$file);
					
					if(time() - $stamp > 86400){
						unlink("tmp/".$file);
					}
				}
			}
			// Redirect
			header("Location: ./");
			exit;
		}  
                
		
	//// logout
	if(isset($_SESSION['user'], $_GET['action']) and $_GET['action'] == "logout"){
		session_unset();
		
		// Redirect
		header("Location: ./");
		exit;
	}
	
		
?>