﻿<?php
require_once ('config.php');
require_once ('classes.php');
require_once ('functions.php');
require_once ('FileMaker.php');
error_reporting(E_CONFIG);

session_start();

if (!isset($_SESSION['user']))
	die('error: login');

if (!isset($_GET['port']))
	die('error: unknown port');

$ppWeb = openDB();

//// PORTS
switch($_GET['port']) {

	// getHours
	case 'getHours' :
		//echo "getHours";
		if (!isset($_GET['member']))
			exit ;
		if (!isset($_GET['date']))
			exit ;

		$command = $ppWeb -> newFindCommand(cHour::webLayout);
		$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $_GET['member']);
		$command -> addFindCriterion('f1_Datum', $_GET['date']);
		$command -> addSortRule('f1_Zeit_Beginn', 1, FILEMAKER_SORT_ASCEND);
		$command -> setPreCommandScript('_ext_Create_PHP_Session', '<member>' + $_GET['member'] + '</member><access>' + $_GET['bn_rechte'] + '<access>');
		$result = $command -> execute();
		//print_r ($result);

		$hours = array();
		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$hours[] = new cHour($ppWeb, $record);
		}

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<hours count="%s">', count($hours));
		foreach ($hours as $hour) {

			$datum = str_replace('/', '.', $hour -> Date());

			printf('<hour');
			printf(' guid="%s"', $hour -> guid());
			printf(' recid="%s"', $hour -> recid());
			printf(' date="%s"', $datum);
			printf(' tstart="%s"', $hour -> TStart());
			printf(' tend="%s"', $hour -> TEnd());
			printf(' duration="%s"', $hour -> Duration());
			printf(' percent="%s"', $hour -> Vertrauensarbeitszeit_Prozent());
			printf(' vertrauensarbeitszeit="%s"', $hour -> Vertrauensarbeitszeit_Flag());
			printf(' notice="%s"', $hour -> Notice());
			printf(' fee="%s"', $hour -> Fee());
			printf(' feecleaered="%s"', $hour -> FeeCleared());
			printf(' feegroup="%s"', $hour -> FeeGroup());
			printf(' project_GUID="%s"', $hour -> ProjectGUID());
			printf(' project_Nr="%s"', $hour -> ProjectNr());
			printf(' job="%s"', $hour -> JobNr());
			printf(' fkJob="%s"', $hour -> fkJob());
			printf(' PositionTitle="%s"', $hour -> PositionTitle());
			printf(' PositionNr="%s"', $hour -> PositionNr());
			printf(' fkPosition="%s"', $hour -> fkPosition());
			printf(' fkMember="%s"', $hour -> fkMember());
			printf(' group="%s"', $hour -> group());
			printf(' factor="%s"', $hour -> factor());
			printf(' travel="%s"', $hour -> travel());
			printf(' ProjektBezeichnung="%s"', $hour -> ProjektBezeichnung());
			printf(' AuftragBezeichnung="%s"', $hour -> AuftragBezeichnung());
			printf(' PositionBezeichnung="%s"', $hour -> PositionBezeichnung());
			printf(' dev_Extended="%s"', $hour -> dev_Extended());

			printf(' />');
		}
		printf('</hours>');
		break;

	// getHour
	case 'getHour' :
		if (!isset($_GET['recid']))
			exit ;

		$hour = new cHour($ppWeb);
		if ($hour -> openRecID($_GET['recid']))
			die('error: ' . $result -> getErrorString());

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<hour');

		$datum = str_replace('/', '.', $hour -> Date());
		printf(' guid="%s"', $hour -> guid());
		printf(' recid="%s"', $hour -> recid());
		printf(' date="%s"', $datum);
		printf(' tstart="%s"', $hour -> getTStart());
		printf(' tend="%s"', $hour -> getTEnd());
		printf(' duration="%s"', $hour -> Duration());
		printf(' percent="%s"', $hour -> Vertrauensarbeitszeit_Prozent());
		printf(' vertrauensarbeitszeit="%s"', $hour -> Vertrauensarbeitszeit_Flag());
		printf(' notice="%s"', $hour -> Notice());
		printf(' fee="%s"', $hour -> Fee());
		printf(' feecleaered="%s"', $hour -> FeeCleared());
		printf(' feegroup="%s"', $hour -> FeeGroup());
		printf(' project_GUID="%s"', $hour -> ProjectGUID());
		printf(' project_Nr="%s"', $hour -> ProjectNr());
		printf(' job="%s"', $hour -> JobNr());
		printf(' fkJob="%s"', $hour -> fkJob());
		printf(' PositionTitle="%s"', $hour -> PositionTitle());
		printf(' PositionNr="%s"', $hour -> PositionNr());
		printf(' fkPosition="%s"', $hour -> fkPosition());
		printf(' fkMember="%s"', $hour -> fkMember());
		printf(' group="%s"', $hour -> group());
		printf(' factor="%s"', $hour -> factor());
		printf(' travel="%s"', $hour -> travel());
		printf(' />');
		break;

	// setHour
	case 'setHour' :
		if (isset($_GET['recid'])) {
			$hour = new cHour($ppWeb);
			if ($hour -> openRecID($_GET['recid']))
				die('error: ' . $result -> getErrorString());
		} else {
			die('error: no matching overload');
		}

		$edit = false;
		if (isset($_GET['date'])) { $hour -> Date($_GET['date']);
			$edit = true;
		}
		if (isset($_GET['tstart'])) { $hour -> TStart($_GET['tstart']);
			$edit = true;
		}
		if (isset($_GET['tend'])) { $hour -> TEnd($_GET['tend']);
			$edit = true;
		}
		if (isset($_GET['duration'])) { $hour -> Duration($_GET['duration']);
			$edit = true;
		}
		if (isset($_GET['percent'])) { $hour -> Vertrauensarbeitszeit_Prozent($_GET['percent']);
			$edit = true;
		}
		if (isset($_GET['vertrauensarbeitszeit'])) { $hour -> Vertrauensarbeitszeit_Flag($_GET['vertrauensarbeitszeit']);
			$edit = true;
		}
		if (isset($_GET['notice'])) { $hour -> Notice($_GET['notice']);
			$edit = true;
		}
		if (isset($_GET['fee'])) { $hour -> Fee($_GET['fee']);
			$edit = true;
		}
		if (isset($_GET['feecleared'])) { $hour -> FeeCleared($_GET['feecleared']);
			$edit = true;
		}
		if (isset($_GET['feegroup'])) { $hour -> FeeGroup($_GET['feegroup']);
			$edit = true;
		}
		if (isset($_GET['fkposition'])) { $hour -> fkPosition($_GET['fkposition']);
			$edit = true;
		}
		if (isset($_GET['group'])) { $hour -> group($_GET['group']);
			$edit = true;
		}
		if (isset($_GET['factor'])) { $hour -> factor($_GET['factor']);
			$edit = true;
		}
		if (isset($_GET['travel'])) { $hour -> travel($_GET['travel']);
			$edit = true;
		}

		if ($edit == true)
			if (FileMaker::IsError($result = $hour -> commit()))
				die($result -> getErrorString());

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<hour');
		printf(' guid="%s"', $hour -> GUID());
		printf(' recid="%s"', $hour -> RecID());
		printf(' date="%s"', $hour -> Date());
		printf(' tstart="%s"', $hour -> TStart());
		printf(' tend="%s"', $hour -> TEnd());
		printf(' duration="%s"', $hour -> Duration());
		printf(' percent="%s"', $hour -> Vertrauensarbeitszeit_Prozent());
		printf(' vertrauensarbeitszeit="%s"', $hour -> Vertrauensarbeitszeit_Flag());
		printf(' notice="%s"', $hour -> Notice());
		printf(' fee="%s"', $hour -> Fee());
		printf(' feecleaered="%s"', $hour -> FeeCleared());
		printf(' feegroup="%s"', $hour -> FeeGroup());
		printf(' project_GUID="%s"', $hour -> ProjectGUID());
		printf(' project_Nr="%s"', $hour -> ProjectNr());
		printf(' job="%s"', $hour -> JobNr());
		printf(' fkJob="%s"', $hour -> fkJob());
		printf(' PositionTitle="%s"', $hour -> PositionTitle());
		printf(' PositionNr="%s"', $hour -> PositionNr());
		printf(' fkPosition="%s"', $hour -> fkPosition());
		printf(' fkMember="%s"', $hour -> fkMember());
		printf(' group="%s"', $hour -> group());
		printf(' factor="%s"', $hour -> factor());
		printf(' travel="%s"', $hour -> travel());
		printf(' />');
		break;

	// newHour
	case 'newHour' :
		if (!isset($_GET['member']))
			exit ;
		if (!isset($_GET['date']))
			exit ;

		$command = $ppWeb -> newAddCommand(cHour::webLayout);
		$result = $command -> execute();

		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$hour = new cHour($ppWeb, $record);
		} else {
			die('error: ' . $result -> getErrorString());
		}

		//Variablen aus der Ajax funktion aus der core.js holen
		$hour -> fkMember($_GET['member']);
		$hour -> Date($_GET['date']);
		$hour -> Notice($_GET['notice']);
		$hour -> TStart($_GET['tstart']);
		$hour -> TEnd($_GET['tend']);
		$hour -> Duration($_GET['duration']);
		$hour -> Vertrauensarbeitszeit_Prozent($_GET['percent']);
		$hour -> Vertrauensarbeitszeit_Flag($_GET['vertrauensarbeitszeit']);
		$hour -> factor($_GET['factor']);
		$hour -> group($_GET['group']);
		$hour -> Fee($_GET['fee']);
		$hour -> travel($_GET['travel']);
		$hour -> fkPosition($_GET['fkPosition']);
		$hour -> FeeGroup($_GET['feegroup']);
		$hour -> commit();

		//XML generieren
		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<hour');
		printf(' guid="%s"', $hour -> GUID());
		printf(' recid="%s"', $hour -> RecID());
		printf(' date="%s"', $hour -> Date());
		printf(' tstart="%s"', $hour -> TStart());
		printf(' tend="%s"', $hour -> TEnd());
		printf(' duration="%s"', $hour -> Duration());
		printf(' percent="%s"', $hour -> Vertrauensarbeitszeit_Prozent());
		printf(' vertrauensarbeitszeit="%s"', $hour -> Vertrauensarbeitszeit_Flag());
		printf(' notice="%s"', $hour -> Notice());
		printf(' fee="%s"', $hour -> Fee());
		printf(' feecleaered="%s"', $hour -> FeeCleared());
		printf(' feegroup="%s"', $hour -> FeeGroup());
		printf(' project="%s"', $hour -> ProjectNr());
		printf(' job="%s"', $hour -> JobNr());
		printf(' fkJob="%s"', $hour -> fkJob());
		printf(' PositionTitle="%s"', $hour -> PositionTitle());
		printf(' PositionNr="%s"', $hour -> PositionNr());
		printf(' fkPosition="%s"', $hour -> fkPosition());
		printf(' fkMember="%s"', $hour -> fkMember());
		printf(' group="%s"', $hour -> group());
		printf(' factor="%s"', $hour -> factor());
		printf(' travel="%s"', $hour -> travel());

		printf(' />');
		break;

	// duplicateHour
	case 'duplicateHour' :
		if (!isset($_GET['recid'])) {
			die('error: no matching overload');
		}

		$command = $ppWeb -> newDuplicateCommand(cHour::webLayout, $_GET['recid']);
		$result = $command -> execute();

		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$hour = new cHour($ppWeb, $record);
		} else {
			die('error: ' . $result -> getErrorString());
		}

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<hour');
		printf(' guid="%s"', $hour -> guid());
		printf(' recid="%s"', $hour -> recid());
		printf(' srcRecid="%s"', $_GET['recid']);
		printf(' date="%s"', $hour -> Date());
		printf(' tstart="%s"', $hour -> TStart());
		printf(' tend="%s"', $hour -> TEnd());
		printf(' duration="%s"', $hour -> Duration());
		printf(' percent="%s"', $hour -> Vertrauensarbeitszeit_Prozent());
		printf(' vertrauensarbeitszeit="%s"', $hour -> Vertrauensarbeitszeit_Flag());
		printf(' notice="%s"', $hour -> Notice());
		printf(' fee="%s"', $hour -> Fee());
		printf(' feecleaered="%s"', $hour -> FeeCleared());
		printf(' feegroup="%s"', $hour -> FeeGroup());
		printf(' project_GUID="%s"', $hour -> ProjectGUID());
		printf(' project_Nr="%s"', $hour -> ProjectNr());
		printf(' job="%s"', $hour -> JobNr());
		printf(' fkJob="%s"', $hour -> fkJob());
		printf(' PositionTitle="%s"', $hour -> PositionTitle());
		printf(' PositionNr="%s"', $hour -> PositionNr());
		printf(' fkPosition="%s"', $hour -> fkPosition());
		printf(' fkMember="%s"', $hour -> fkMember());
		printf(' group="%s"', $hour -> group());
		printf(' factor="%s"', $hour -> factor());
		printf(' travel="%s"', $hour -> travel());
		printf(' />');
		break;

	// deleteHour
	case 'deleteHour' :
		if (!isset($_GET['recid']))
			exit ;

		$hour = new cHour($ppWeb);
		if ($hour -> openRecID($_GET['recid']))
			die('error: ' . $result -> getErrorString());

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		if ($hour -> delete()) { printf('<delete recid="%s" error="%s"/>', $_GET['recid'], 1);
			exit ;
		}
		printf('<delete recid="%s" error="%s"/>', $_GET['recid'], 0);
		break;

	// getProjects
	case 'getProjects' :
		if (!isset($_GET['member']))
			exit ;
		$token = $_GET['member'];
		$profitcenter = $_GET['profitcenter'];
		$NurZE_PC = $_GET['flag_NurZE_ProfitCenter'];
		//echo "NurZE_PC:" . $NurZE_PC;

		$filePath = "tmp/".$token;
		if(file_exists($filePath)){
			$file = fopen($filePath, "r");
			$content = fread($file, filesize($filePath));
			fclose($file);
			header('Content-Type: text/xml');
			echo $content;
			break;
		}

		$command = $ppWeb -> newCompoundFindCommand(cJob::webLayout);
		$subcommand[0] = $ppWeb -> newFindRequest(cJob::webLayout);
		if ($NurZE_PC == "1") {$subcommand[0] -> addFindCriterion('f1_FKey_Profitcenter', $profitcenter);
		}
		$subcommand[0] -> addFindCriterion('job_app_Project::f1_ZeiterfassungZulaessig_flag', '1');
		$subcommand[0] -> addFindCriterion('job_app_Project_Projektleiter_Benutzer_Mitarbeiter::f1_GUID', $token);
		$subcommand[0] -> setOmit(false);
		$command -> add(1, $subcommand[0]);

		if ($token !== null) {
			$subcommand[1] = $ppWeb -> newFindRequest(cJob::webLayout);
			if ($NurZE_PC == "1") {$subcommand[1] -> addFindCriterion('f1_FKey_Profitcenter', $profitcenter);
			}
			$subcommand[1] -> addFindCriterion('job_app_Project::f1_ZeiterfassungZulaessig_flag', '1');
			$subcommand[1] -> addFindCriterion('job_app_Project_X_Benutzer_User_Mitarbeiter::f1_GUID', $token);
			$subcommand[1] -> setOmit(false);
			$command -> add(2, $subcommand[1]);
		}

		if ($token !== null) {
			$subcommand[2] = $ppWeb -> newFindRequest(cJob::webLayout);
			if ($NurZE_PC == "1") {$subcommand[2] -> addFindCriterion('f1_FKey_Profitcenter', $profitcenter);
			}
			$subcommand[2] -> addFindCriterion('job_app_Project::f1_ZeiterfassungZulaessig_flag', '1');
			$subcommand[2] -> addFindCriterion('job_app_Project::ss_ze_Mitarbeiterprojekte', 'all');
			$subcommand[2] -> setOmit(false);
			$command -> add(3, $subcommand[2]);
		}

		if ($token !== null) {
			$subcommand[3] = $ppWeb -> newFindRequest(cJob::webLayout);
			$subcommand[3] -> addFindCriterion('f4_Zeiterfassung_Erweiterung', $token);
			$subcommand[3] -> setOmit(false);
			$command -> add(4, $subcommand[3]);
		}

		if ($token !== null) {
			$subcommand[4] = $ppWeb -> newFindRequest(cJob::webLayout);
			$subcommand[4] -> addFindCriterion('f4_Zeiterfassung_Einschraenkung', $token);
			$subcommand[4] -> setOmit(true);
			$command -> add(5, $subcommand[4]);
		}

		if ($token !== null) {
			$subcommand[5] = $ppWeb -> newFindRequest(cJob::webLayout);
			$subcommand[5] -> addFindCriterion('job_app_Project::f1_ZeiterfassungZulaessig_flag', '1');
			$subcommand[5] -> addFindCriterion('job_app_Project::f1_Innenprojekt_Flag', '1');
			$subcommand[5] -> setOmit(false);
			$command -> add(6, $subcommand[5]);
		}

		$command -> setPreCommandScript('_ext_Create_PHP_Session', '<member>' + $_GET['member'] + '</member><access>' + $_GET['bn_rechte'] + '<access>');
		$command -> addSortRule('job_app_Project::f1_Nr', 1, FILEMAKER_SORT_ASCEND);
		$result = $command -> execute();
		unset($command, $subcommand);
		if (iserror($result)) { printerror($result -> getErrorString());
			exit ;
		}

		$records = $result -> getRecords();
		if (!FileMaker::IsError($result)) {
			foreach ($records as $record)
				$projects[] = new cJob($ppWeb, $record);
		}

		//Ermitteln der maximalen Anzahl der Projekte
		$cur = 0;
		foreach ($projects as $project) {

			$tmp_GUID = $project -> Project_GUID();
			if ($tmp_Array[$tmp_GUID] != true) {
				$cur++;
			}
			$tmp_Array[$tmp_GUID] = true;
		}
		$tmp_Array = null;

		$pageContent = '';

		header('Content-Type: text/xml');
		$pageContent .= sprintf('<?xml version="1.0" encoding="utf-8"?>');
		$pageContent .= sprintf('<projects count="%s">', $cur);
		foreach ($projects as $project) {

			$tmp_GUID = $project -> Project_GUID();
			if ($tmp_Array[$tmp_GUID] != true) {
				$pageContent .= sprintf('<project');
				$pageContent .= sprintf(' guid="%s"', $project -> Project_GUID());
				$pageContent .= sprintf(' recid="%s"', $project -> Project_sRecID());
				$pageContent .= sprintf(' nr="%s"', $project -> Project_Nr());
				$pageContent .= sprintf(' name="%s"', $project -> Project_Name());
				$pageContent .= sprintf(' fkey_Adr="%s"', $project -> Project_FKey_ADR());
				$pageContent .= sprintf(' />');
			}
			$tmp_Array[$tmp_GUID] = true;
		}
		$pageContent .= sprintf('</projects>');

		if (!is_dir("tmp/")) {
			mkdir("tmp");
		}


		$file = fopen($filePath, "w+");
		fwrite($file, $pageContent);
		fclose($file);
		echo $pageContent;
		break;

	// getJobs
	case 'getJobs' :
		if (!isset($_GET['project']))
			die('error: missing parameter');
		$token = $_GET['member'];
		$profitcenter = $_GET['profitcenter'];
		$NurZE_PC = $_GET['flag_NurZE_ProfitCenter'];

		$command = $ppWeb -> newCompoundFindCommand(cJob::webLayout);
		$subcommand[0] = $ppWeb -> newFindRequest(cJob::webLayout);
		$subcommand[0] -> addFindCriterion('job_app_Project::f1_GUID', "==" . $_GET['project']);
		$subcommand[0] -> addFindCriterion('s_zeiterfassung_Flag_Valuelist', '1');
		if ($NurZE_PC == "1") {$subcommand[0] -> addFindCriterion('f1_FKey_Profitcenter', $profitcenter);
		}
		$subcommand[0] -> setOmit(false);
		$command -> add(1, $subcommand[0]);

		if ($token !== null) {
			$subcommand[1] = $ppWeb -> newFindRequest(cJob::webLayout);
			if ($NurZE_PC == "1") {$subcommand[1] -> addFindCriterion('f1_FKey_Profitcenter', $profitcenter);
			}
			$subcommand[1] -> addFindCriterion('f1_ag_FKey_Adr', '1');
			$subcommand[1] -> addFindCriterion('s_zeiterfassung_Flag_Valuelist', 1);
			$subcommand[1] -> setOmit(false);
			$command -> add(2, $subcommand[1]);
		}

		if ($token !== null) {
			$subcommand[2] = $ppWeb -> newFindRequest(cJob::webLayout);
			if ($NurZE_PC == "1") {$subcommand[1] -> addFindCriterion('f1_FKey_Profitcenter', $profitcenter);
			}
			$subcommand[2] -> addFindCriterion('job_app_Project::f1_GUID', "==" . $_GET['project']);
			$subcommand[2] -> addFindCriterion('f4_Zeiterfassung_Erweiterung', $token);
			$subcommand[2] -> setOmit(false);
			$command -> add(3, $subcommand[2]);
		}

		if ($token !== null) {
			$subcommand[3] = $ppWeb -> newFindRequest(cJob::webLayout);
			$subcommand[3] -> addFindCriterion('f4_Zeiterfassung_Einschraenkung', $token);
			$subcommand[3] -> setOmit(true);
			$command -> add(4, $subcommand[3]);
		}

		$subcommand[4] = $ppWeb -> newFindRequest(cJob::webLayout);
		$subcommand[4] -> addFindCriterion('job_app_Project::f1_GUID', "==" . $_GET['project']);
		$subcommand[4] -> addFindCriterion('s_zeiterfassung_Flag_Valuelist', '1');
		$subcommand[4] -> addFindCriterion('f1_Innenauftrag_Flag', "1");
		if ($NurZE_PC == "1") {$subcommand[4] -> addFindCriterion('f1_FKey_Profitcenter', $profitcenter);
		}
		$subcommand[4] -> setOmit(false);
		$command -> add(5, $subcommand[4]);

		$subcommand[5] = $ppWeb -> newFindRequest(cJob::webLayout);
		$subcommand[5] -> addFindCriterion('job_app_Project::f1_GUID', "==" . $_GET['project']);
		$subcommand[5] -> addFindCriterion('job_app_Project::f1_Innenprojekt_Flag', '1');
		$subcommand[5] -> addFindCriterion('s_zeiterfassung_Flag_Valuelist', '1');
		$subcommand[5] -> addFindCriterion('f1_Innenauftrag_Flag', "1");
		$subcommand[5] -> setOmit(false);
		$command -> add(6, $subcommand[5]);

		$command -> setPreCommandScript('_ext_Create_PHP_Session', '<member>' + $_GET['member'] + '</member><access>' + $_GET['bn_rechte'] + '<access>');
		$command -> addSortRule('f1_Nr', 1, FILEMAKER_SORT_ASCEND);
		$result = $command -> execute();
		unset($command, $subcommand);
		if (iserror($result)) { printerror($result -> getErrorString());
			exit ;
		}

		//$command->addSortRule('f1_Nr', 1, FILEMAKER_SORT_ASCEND);
		//$result = $command->execute();

		$jobs = array();
		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$jobs[] = new cJob($ppWeb, $record);
		}

		header('Content-Type: text/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<jobs count="%s">', count($jobs));
		foreach ($jobs as $job) {
			printf('<job');
			printf(' guid="%s"', $job -> guid());
			printf(' recid="%s"', $job -> RecID());
			printf(' nr="%s"', $job -> nr());
			printf(' name="%s"', $job -> name());
			printf(' />');
		}
		printf('</jobs>');
		break;

	// getPositions
	case 'getPositions' :
		if (!isset($_GET['job']))
			die('error: parameter missing');

		$command = $ppWeb -> newFindCommand(cPosition::webLayout);
		$command -> addFindCriterion('f1_FKey_Auftrag', $_GET['job']);
		$command -> addFindCriterion('s_zeiterfassung_flag_valuelist', '1');
		$command -> addSortRule('f1_NrT', 1, FILEMAKER_SORT_ASCEND);
		$command -> addSortRule('f1_Nr', 2, FILEMAKER_SORT_ASCEND);

		$result = $command -> execute();

		$positions = array();
		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$positions[] = new cPosition($ppWeb, $record);
		}

		$titles = array();
		foreach ($positions as $pos) {
			if ($pos -> Nr() == '') {
				$titles[$pos -> Title()]['nr'] = $pos -> Title();
				$titles[$pos -> Title()]['name'] = $pos -> Name();
			} else {
				$titles[$pos -> Title()]['positions'][] = $pos;
			}
		}

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<titles count="%s">', count($titles));
		foreach ($titles as $title) {
			printf('<title');
			printf(' nr="%s"', (isset($title['nr']) ? $title['nr'] : ''));
			printf(' name="%s"', (isset($title['name']) ? $title['name'] : ''));
			if (isset($title['positions']))
				printf(' positions="%s"', count($title['positions']));
			printf(' >');
			if (isset($title['positions']))
				foreach ($title['positions'] as $position) {
					printf('<position');
					printf(' guid="%s"', $position -> guid());
					printf(' recid="%s"', $position -> RecID());
					printf(' nr="%s"', $position -> nr());
					printf(' title="%s"', $position -> Title());
					printf(' name="%s"', $position -> name());
					printf(' project="%s"', $position -> project());
					printf(' job="%s"', $position -> Job());
					printf(' fkjob="%s"', $position -> FKeyJob());
					printf(' fee="%s"', $position -> Fee());
					printf(' />');
				}
			printf('</title>');
		}
		printf('</titles>');
		break;

	// getGroup
	case 'getGroup' :
		if (!isset($_GET['position']))
			die('error: parameter missing');

		$command = $ppWeb -> newFindCommand(cPosition::webLayout);
		$command -> addFindCriterion('f1_GUID', $_GET['position']);
		$result = $command -> execute();

		$groups = array();
		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$groups[] = new cPosition($ppWeb, $record);
		}

		header('Content-Type: text/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<groups count="%s">', count($groups));
		foreach ($groups as $group) {
			printf('<group');
			printf(' name="%s"', $group -> Group());
			printf(' />');
		}
		printf('</groups>');

		break;
	//WebStempelUhr
	case 'newClockTime' :
		if (!isset($_GET['member']))
			exit ;

		$command = $ppWeb -> newAddCommand(cTimeClock::webLayout);
		$result = $command -> execute();

		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$TimeClock = new cTimeClock($ppWeb, $record);
		} else {
			//die('error: '. $result->getErrorString());
		}

		$edit = false;
		if (isset($_GET['member'])) { $TimeClock -> Member($_GET['member']);
			$edit = true;
		}
		if (isset($_GET['date'])) { $TimeClock -> Date($_GET['date']);
			$edit = true;
		}
		if (isset($_GET['time_begin'])) { $TimeClock -> Begin($_GET['time_begin']);
			$edit = true;
		}
		if (isset($_GET['time_end'])) { $TimeClock -> End($_GET['time_end']);
			$edit = true;
		}
		if (isset($_GET['notice'])) { $TimeClock -> Notice($_GET['notice']);
			$edit = true;
		}
		if (isset($_GET['recordtype'])) { $TimeClock -> RecordType($_GET['recordtype']);
			$edit = true;
		}

		if ($edit == true)
			if (FileMaker::IsError($result = $TimeClock -> commit()))/*die($result->getErrorString());*/
				$TimeClock -> commit();

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<ClockTime');
		printf(' guid="%s"', $TimeClock -> GUID());
		printf(' member="%s"', $TimeClock -> Member());
		printf(' recid="%s"', $TimeClock -> RecID());
		printf(' date="%s"', $TimeClock -> Date());
		printf(' notice="%s"', $TimeClock -> Notice());
		printf(' begin="%s"', $TimeClock -> Begin());
		printf(' end="%s"', $TimeClock -> End());
		printf(' recordtype="%s"', $TimeClock -> RecordType());
		printf(' />');

		break;

	case 'editClockTime' :
		if (!isset($_GET['recid']))
			exit ;
		if (isset($_GET['recid'])) {
			$TimeClock = new cTimeClock($ppWeb);
			if ($TimeClock -> openRecID($_GET['recid']))/*die('error: '. $result->getErrorString());*/
				;
		} else {
			//die('error: no matching overload');
		}

		$edit = false;
		if (isset($_GET['member'])) { $TimeClock -> Member($_GET['member']);
			$edit = true;
		}
		if (isset($_GET['date'])) { $TimeClock -> Date($_GET['date']);
			$edit = true;
		}
		if (isset($_GET['time_begin'])) { $TimeClock -> Begin($_GET['time_begin']);
			$edit = true;
		}
		if (isset($_GET['time_end'])) { $TimeClock -> End($_GET['time_end']);
			$edit = true;
		}
		if (isset($_GET['notice'])) { $TimeClock -> Notice($_GET['notice']);
			$edit = true;
		}
		if (isset($_GET['recordtype'])) { $TimeClock -> RecordType($_GET['recordtype']);
			$edit = true;
		}

		if ($edit == true)
			if (FileMaker::IsError($result = $TimeClock -> commit()))/*die($result->getErrorString());*/
				$TimeClock -> commit();

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<ClockTime');
		printf(' guid="%s"', $TimeClock -> GUID());
		printf(' member="%s"', $TimeClock -> Member());
		printf(' recid="%s"', $TimeClock -> RecID());
		printf(' date="%s"', $TimeClock -> Date());
		printf(' begin="%s"', $TimeClock -> Begin());
		printf(' notice="%s"', $TimeClock -> Notice());
		printf(' end="%s"', $TimeClock -> End());
		printf(' recordtype="%s"', $TimeClock -> RecordType());
		printf(' duration="%s"', $TimeClock -> ArbeitsStunden_res());
		printf(' />');

		break;

	// get ClockTime
	case 'getClockTime' :
		if (!isset($_GET['date']))
			die('error: missing parameter');
		if (!isset($_GET['member']))
			die('error: missing parameter');

		$command = $ppWeb -> newFindCommand(cTimeClock::webLayout);
		$command -> addFindCriterion('f1_Datum', "==" . $_GET['date']);
		$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $_GET['member']);
		$command -> addSortRule('f1_Beginn', 1, FILEMAKER_SORT_ASCEND);
		$result = $command -> execute();

		$ClockTimes = array();
		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$ClockTimes[] = new cTimeClock($ppWeb, $record);
		}

		header('Content-Type: application/xml');
		header("Cache-Control: max-age=1, must-revalidate");
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<ClockTimes count="%s">', count($ClockTimes));
		foreach ($ClockTimes as $TimeClock) {

			$datum = str_replace('/', '.', $TimeClock -> Date());

			printf('<ClockTime');
			printf(' guid="%s"', $TimeClock -> GUID());
			printf(' member="%s"', $TimeClock -> Member());
			printf(' recid="%s"', $TimeClock -> RecID());
			printf(' date="%s"', $datum);
			printf(' begin="%s"', $TimeClock -> Begin());
			printf(' end="%s"', $TimeClock -> End());
			printf(' recordtype="%s"', $TimeClock -> RecordType());
			printf(' notice="%s"', $TimeClock -> Notice());
			printf(' duration="%s"', $TimeClock -> ArbeitsStunden_res());
			printf(' />');
		}
		printf('</ClockTimes>');

		break;

	// get ClockTime
	case 'getLastClockTime' :
		if (!isset($_GET['date']))
			die('error: missing parameter');
		if (!isset($_GET['member']))
			die('error: missing parameter');
		if (!isset($_GET['recordtype']))
			die('error: missing parameter');

		$command = $ppWeb -> newFindCommand(cTimeClock::webLayout);
		$command -> addFindCriterion('f1_Datum', "==" . $_GET['date']);
		$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $_GET['member']);
		$command -> addFindCriterion('f1_Recordtyp', "==" . $_GET['recordtype']);
		$command -> addSortRule('f1_Ende', 1, FILEMAKER_SORT_DESCEND);
		$command -> addSortRule('s_RecID', 1, FILEMAKER_SORT_DESCEND);
		$command -> setRange(0, 1);
		$result = $command -> execute();

		$ClockTimes = array();
		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$ClockTimes[] = new cTimeClock($ppWeb, $record);
		}

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<ClockTimes count="%s">', count($ClockTimes));
		foreach ($ClockTimes as $TimeClock) {

			$datum = str_replace('/', '.', $TimeClock -> Date());

			printf('<ClockTime');
			printf(' guid="%s"', $TimeClock -> GUID());
			printf(' recid="%s"', $TimeClock -> RecID());
			printf(' begin="%s"', $TimeClock -> Begin());
			printf(' end="%s"', $TimeClock -> End());
			printf(' recordtype="%s"', $TimeClock -> RecordType());
			printf(' />');
		}
		printf('</ClockTimes>');

		break;

	// get last open ClockTime
	case 'getLastDaysOpenClockTime' :
		if (!isset($_GET['date']))
			die('error: missing parameter');
		if (!isset($_GET['member']))
			die('error: missing parameter');
		if (!isset($_GET['recordtype']))
			die('error: missing parameter');

		$command = $ppWeb -> newFindCommand(cTimeClock::webLayout);
		$command -> addFindCriterion('f1_Datum', "<" . $_GET['date']);
		$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $_GET['member']);
		$command -> addFindCriterion('f1_Recordtyp', "==" . $_GET['recordtype']);
		$command -> addFindCriterion('s_offen_flag', "==" . 1);
		$command -> addSortRule('f1_Ende', 1, FILEMAKER_SORT_DESCEND);
		$command -> addSortRule('s_RecID', 1, FILEMAKER_SORT_DESCEND);
		$command -> setRange(0, 1);
		$result = $command -> execute();

		$ClockTimes = array();
		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$ClockTimes[] = new cTimeClock($ppWeb, $record);
		}

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<ClockTimes count="%s">', count($ClockTimes));
		foreach ($ClockTimes as $TimeClock) {

			$datum = str_replace('/', '.', $TimeClock -> Date());

			printf('<ClockTime');
			printf(' guid="%s"', $TimeClock -> GUID());
			printf(' recid="%s"', $TimeClock -> RecID());
			printf(' begin="%s"', $TimeClock -> Begin());
			printf(' end="%s"', $TimeClock -> End());
			printf(' recordtype="%s"', $TimeClock -> RecordType());
			printf(' />');
		}
		printf('</ClockTimes>');

		break;

	// getClockTime_recid
	case 'vertrauensarbeiszeit' :
		if (!isset($_GET['member']))
			exit ;
		if (!isset($_GET['date']))
			exit ;
		$vertrauensarbeistzeit = vertrauensarbeitszeit($_GET['member'], $_GET['date']);
		echo $vertrauensarbeistzeit;
		break;
	case 'getClockTime_recid' :
		if (!isset($_GET['recid']))
			die('error: missing parameter');

		$command = $ppWeb -> newFindCommand(cTimeClock::webLayout);
		$command -> addFindCriterion('s_RecID', "==" . $_GET['recid']);
		$result = $command -> execute();

		$ClockTimes = array();
		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$ClockTimes[] = new cTimeClock($ppWeb, $record);
		}

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<ClockTimes count="%s">', count($ClockTimes));
		foreach ($ClockTimes as $TimeClock) {

			$datum = str_replace('/', '.', $TimeClock -> Date());
			printf('<ClockTime');
			printf(' guid="%s"', $TimeClock -> GUID());
			printf(' member="%s"', $TimeClock -> Member());
			printf(' recid="%s"', $TimeClock -> RecID());
			printf(' date="%s"', $datum);
			printf(' begin="%s"', $TimeClock -> Begin());
			printf(' end="%s"', $TimeClock -> End());
			printf(' />');
		}
		printf('</ClockTimes>');

		break;

	// delete ClockTime
	case 'deleteClockTime' :
		if (!isset($_GET['recid']))
			exit ;

		$command = $ppWeb -> newFindCommand("web_zeiterfassung_PRC_MitarbArbeitszeit");
		$command -> addFindCriterion('s_RecID', "==" . $_GET['recid']);
		$result = $command -> execute();
		//print_r($result);

		$ClockTime = new cTimeClock($ppWeb);
		$ClockTime -> openRecID($_GET['recid']);
		$ClockTime -> delete();

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<delete recid="%s" error="%s"/>', $_GET['recid'], 0);

		break;

	case 'GetMitarb' :
		if (!isset($_GET['member']))
			exit ;

		$command = $ppWeb -> newFindCommand(cMember::webLayout);
		$command -> addFindCriterion('f1_GUID', "==" . $_GET['member']);
		$result = $command -> execute();
		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$sum = new cMember($ppWeb, $record);
		} else {
			//die('error: '. $result->getErrorString());
		}

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<Mitarb');
		printf(' Calender="%s"', $sum -> CalenderFKey());
		printf(' />');

		break;

	case 'GetSum_ArbeitZeit' :
		if (!isset($_GET['member']))
			exit ;
		if (!isset($_GET['date']))
			exit ;
		$command = $ppWeb -> newFindCommand(cGetSum_ArbeitZeit::webLayout);
		$command -> addFindCriterion('f1_Datum', "==" . $_GET['date']);
		$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $_GET['member']);
		$result = $command -> execute();

		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$sum = new cGetSum_ArbeitZeit($ppWeb, $record);
		} else {
			header('Content-Type: application/xml');
			printf('<?xml version="1.0" encoding="utf-8"?>');
			printf('<Stunden');
			printf(' sum_std="%s"', '0');
			printf(' />');
			die();
			//die('error: '. $result->getErrorString());
		}

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<Stunden');
		printf(' sum_std="%s"', $sum -> sum_std());
		printf(' />');

		break;

	case 'GetSum_ProjektZeit' :
		if (!isset($_GET['member']))
			exit ;
		if (!isset($_GET['date']))
			exit ;

		$command = $ppWeb -> newFindCommand(cGetSum_ProjektZeit::webLayout);
		$command -> addFindCriterion('f1_Datum', "==" . $_GET['date']);
		$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $_GET['member']);
		$result = $command -> execute();

		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$sum = new cGetSum_ProjektZeit($ppWeb, $record);
		} else {
			header('Content-Type: application/xml');
			printf('<?xml version="1.0" encoding="utf-8"?>');
			printf('<Stunden');
			printf(' std="%s"', "0");
			printf(' />');
			die();
			//die('error: '. $result->getErrorString());
		}

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<Stunden');
		printf(' std="%s"', $sum -> sum_Std());
		printf(' StdStd="%s"', $sum -> StdStd());
		printf(' />');

		break;

	case 'GetDayAnalysis' :
		if (!isset($_GET['member']))
			exit ;
		if (!isset($_GET['date']))
			exit ;

		$command = $ppWeb -> newFindCommand(cGetDayAnalysis::webLayout);
		$command -> addFindCriterion('f1_Datum', "==" . $_GET['date']);
		$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $_GET['member']);
		$result = $command -> execute();

		if (!FileMaker::IsError($result)) {

			$records = $result -> getRecords();

			header('Content-Type: application/xml');
			printf('<?xml version="1.0" encoding="utf-8"?>');
			printf('<Records count="%s">', count($records));
			foreach ($records as $record) {
				printf('<record');
				printf(' FKeyMitarbeiter="%s"', $record -> getField('f1_FKey_Mitarbeiter'));
				printf(' ArbeitsStd_Res="%s"', $record -> getField('f3_ArbeitsStd_Res'));
				printf(' date="%s"', $record -> getField('f1_Datum'));
				printf(' />');
			}
			printf('</Records>');

		} else {
			header('Content-Type: application/xml');
			printf('<?xml version="1.0" encoding="utf-8"?>');
			printf('<Records count="%s">', "1");
			printf('<record');
			printf(' FKeyMitarbeiter="%s"', $_GET['member']);
			printf(' ArbeitsStd_Res="%s"', "0");
			printf(' date="%s"', $_GET['date']);
			printf(' />');
			printf('</Records>');

			exit ;
		}

		break;

	case 'GetMitArbAnalysis' :
		if (!isset($_GET['FKeyKalender']))
			exit ;
		if (!isset($_GET['date']))
			exit ;

		$command = $ppWeb -> newFindCommand(cGetDayAnalysis::webLayout);
		$command -> addFindCriterion('f1_Datum', "==" . $_GET['date']);
		$command -> addFindCriterion('f1_FKey_Kalender', "==" . $_GET['FKeyKalender']);
		$result = $command -> execute();

		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$sum = new cGetDayAnalysis($ppWeb, $record);
		} else {
			//die('error: '. $result->getErrorString());
		}

		$datum = str_replace('/', '.', $sum -> date());
		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<SollStunden');
		printf(' FKeyKalender="%s"', $sum -> FKeyKalender());
		printf(' ArbeitsStd_soll="%s"', $sum -> ArbeitsStd_soll());
		printf(' date="%s"', $datum);
		printf(' />');

		break;

	case 'GetMitarbUeberstunden' :
		if (!isset($_GET['member']))
			exit ;
		if (!isset($_GET['date']))
			exit ;

		$datum = $_GET['date'];
		$datum_array = explode("/", $datum);

		$command = $ppWeb -> newFindCommand(cUeberstunden::webLayout);
		$command -> addFindCriterion('f1_Monat', "==" . $datum_array[0]);
		$command -> addFindCriterion('f1_Jahr', "==" . $datum_array[2]);
		$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $_GET['member']);
		$command -> addFindCriterion('s_Monat_flag', "==" . "1");
		$result = $command -> execute();

		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$sum = new cUeberstunden($ppWeb, $record);
		} else {
			//die('error: '. $result->getErrorString());
		}

		$Ueberstunden = $sum -> Ueberstunden();
		$UeberstundenToleranz = $sum -> UeberstundenToleranz();

		$command = $ppWeb -> newFindCommand(cUeberstunden::webLayout);
		$command -> addFindCriterion('f1_Jahr', "==" . $datum_array[2]);
		$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $_GET['member']);
		$command -> addFindCriterion('s_Jahr_flag', "==" . "1");
		$result = $command -> execute();

		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$sum = new cUeberstunden($ppWeb, $record);
		} else {
			//die('error: '. $result->getErrorString());
		}

		$Resturlaub = $sum -> Resturlaub();
		$UeberstundenJahr = $sum -> UeberstundenJahr();

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<Sum');
		printf(' ueberstunden="%s"', $Ueberstunden);
		printf(' ueberstdtoleranz="%s"', $UeberstundenToleranz);
		printf(' Resturlaub="%s"', $Resturlaub);
		printf(' UeberstundenJahr="%s"', $UeberstundenJahr);
		printf(' />');

		break;

	case 'GetWeb_stempeluhr_Arbeitszeitmodell_Arbeitstag' :
		if (!isset($_GET['member']))
			exit ;
		if (!isset($_GET['date']))
			exit ;

		$command = $ppWeb -> newFindCommand(cGetWeb_stempeluhr_Arbeitszeitmodell_Arbeitstag::webLayout);
		$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $_GET['member']);
		$command -> addFindCriterion('f1_Datum', $_GET['date']);
		$result = $command -> execute();

		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$sum = new cGetWeb_stempeluhr_Arbeitszeitmodell_Arbeitstag($ppWeb, $record);
		}

		$datum = str_replace('/', '.', $DAY -> Date());

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<Sum');
		printf(' FKey_Mitarb="%s"', $sum -> FKey_Mitarb());
		printf(' Typ="%s"', $sum -> Typ());
		printf(' Bezeichnung="%s"', $sum -> Bezeichnung());
		printf(' Date="%s"', $datum);
		printf(' />');

		break;
	case 'Vertrauensarbeitszeit' :
		$command = $ppWeb -> newFindCommand(cGetWeb_stempeluhr_Arbeitszeitmodell_Arbeitstag::webLayout);
		$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $_GET['member']);
		$command -> addFindCriterion('f1_Datum', "==" . $_GET['date']);
		$command -> addFindCriterion('f1_Typ', "1");
		$command -> addFindCriterion('s_Arbeitstag_Flag', "1");

		$result = $command -> execute();

		$DAYs = array();
		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$DAYs[] = new cGetWeb_stempeluhr_Arbeitszeitmodell_Arbeitstag($ppWeb, $record);
		}
		$result = array();
		foreach ($DAYs as $DAY) {
			$datum = str_replace('/', '.', $DAY -> Date());
			$json = array('Typ' => $DAY -> Typ(), 'Bezeichnung' => $DAY -> Bezeichnung(), 'Vertrauensarbeitszeit' => $DAY -> Vertrauensarbeitszeit(), 'Date' => $datum);
			array_push($result, $json);
		}
		header('Content-type: application/json');
		printf(json_encode($result));
		break;
	case 'Arbeitszeitmodell_Arbeitstag' :
		if (!isset($_GET['member']))
			exit ;
		//if(!isset($_GET['Date'])) exit;

		$command = $ppWeb -> newFindCommand(cGetWeb_stempeluhr_Arbeitszeitmodell_Arbeitstag::webLayout);
		$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $_GET['member']);
		//$command->addFindCriterion('f1_Datum', "==" . $_GET['Date']);
		$command -> addFindCriterion('f1_Typ', ">" . "1");

		$result = $command -> execute();

		$DAYs = array();
		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$DAYs[] = new cGetWeb_stempeluhr_Arbeitszeitmodell_Arbeitstag($ppWeb, $record);
		}

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<Records count="%s">', count($DAYs));
		foreach ($DAYs as $DAY) {
			$datum = str_replace('/', '.', $DAY -> Date());

			printf('<record');
			printf(' Typ="%s"', $DAY -> Typ());
			printf(' Bezeichnung="%s"', $DAY -> Bezeichnung());
			printf(' Vertrauensarbeitszeit="%s"', $DAY -> Vertrauensarbeitszeit());
			printf(' Date="%s"', $datum);
			printf(' />');
		}
		printf('</Records>');

		break;

	case 'GetZeitHonorarktegorie' :
		// default
		if (!isset($_GET['Job']))
			exit ;

		$command = $ppWeb -> newFindCommand(cGetZeitHonorarktegorie::webLayout);
		$command -> addFindCriterion('f1_FKey_Auftrag', "==" . $_GET['Job']);
		$command -> addSortRule('f1_Kategorie', 1, FILEMAKER_SORT_ASCEND);
		$result = $command -> execute();

		$CATEGORIEs = array();
		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$CATEGORIEs[] = new cGetZeitHonorarktegorie($ppWeb, $record);
		}

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<Records count="%s">', count($CATEGORIEs));
		foreach ($CATEGORIEs as $CATEGORIE) {
			printf('<record');
			printf(' Auftrag="%s"', $CATEGORIE -> Auftrag());
			printf(' Kategorie="%s"', $CATEGORIE -> Kategorie());
			printf(' Beschreibung="%s"', $CATEGORIE -> Beschreibung());
			printf(' />');
		}
		printf('</Records>');
		break;

	case 'newGroup' :
		if (!isset($_GET['Position']))
			exit ;
		$command = $ppWeb -> newFindCommand(cHour::webLayout);
		$command -> addFindCriterion('f1_FKey_Position', "==" . $_GET['Position']);
		//$editRecord = $ppWeb->newEditCommand(cHour::webLayout);
		//$editRecord->setField('hour_app_Position::f1_ZEGruppen_Eintraege', "test1\ntest2\ntest3");

		$result = $command -> execute();
		//$result = $editRecord->execute();

		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record) {
				//$sum = new cHour($ppWeb, $record);
				//$gruppen = $record->getField('hour_app_Position::f1_ZEGruppen_Eintraege');
				$record -> setField('hour_app_Position::f1_ZEGruppen_Eintraege', $record -> getField('hour_app_Position::f3_ZEGruppen_Eintraege') . "||" . $_GET['groups']);
				$record -> commit();
			}
		}

		break;
	case 'getEmployer' :
		if (!isset($_GET['member']))
			exit ;
		;
		$token = $_GET['member'];

		$tokenMember = $token;
		foreach ($_SESSION['members'] as $value) {
			if($value['token'] == $tokenMember){
				$token = $value['UserGUID'];
				break;
			}
		}

		$command = $ppWeb -> newCompoundFindCommand(cWeb_zeiterfassung_Kunde::webLayout);
		$subcommand[0] = $ppWeb -> newFindRequest(cWeb_zeiterfassung_Kunde::webLayout);
		$subcommand[0] -> addFindCriterion('cknd_app_Projekt::f1_ZeiterfassungZulaessig_flag', '1');
		$subcommand[0] -> addFindCriterion('cknd_app_Projekt::ss_ze_Mitarbeiterprojekte', $token);
		$subcommand[0] -> setOmit(false);
		$command -> add(1, $subcommand[0]);

		$subcommand[1] = $ppWeb -> newFindRequest(cWeb_zeiterfassung_Kunde::webLayout);
		$subcommand[1] -> addFindCriterion('cknd_app_Projekt::f1_ZeiterfassungZulaessig_flag', '1');
		$subcommand[1] -> addFindCriterion('cknd_app_Projekt::ss_ze_mitarbeiterprojekte', 'alle');
		$subcommand[1] -> setOmit(false);
		$command -> add(2, $subcommand[1]);

		$subcommand[2] = $ppWeb -> newFindRequest(cWeb_zeiterfassung_Kunde::webLayout);
		$subcommand[2] -> addFindCriterion('cknd_app_Auftraege::s_Zeiterfassung_Flag_Valuelist', '1');
		$subcommand[2] -> addFindCriterion('cknd_app_Auftraege_Projekt::f1_ZeiterfassungZulaessig_flag', '1');
		$subcommand[2] -> addFindCriterion('cknd_app_Auftraege_Projekt::ss_ze_mitarbeiterprojekte', $token);
		$subcommand[2] -> setOmit(false);
		$command -> add(3, $subcommand[2]);

		$subcommand[3] = $ppWeb -> newFindRequest(cWeb_zeiterfassung_Kunde::webLayout);
		$subcommand[3] -> addFindCriterion('cknd_app_Auftraege::s_Zeiterfassung_Flag_Valuelist', '1');
		$subcommand[3] -> addFindCriterion('cknd_app_Auftraege_Projekt::f1_ZeiterfassungZulaessig_flag', '1');
		$subcommand[3] -> addFindCriterion('cknd_app_Auftraege_Projekt::ss_ze_mitarbeiterprojekte', 'all');
		$subcommand[3] -> setOmit(false);
		$command -> add(4, $subcommand[3]);

		$subcommand[4] = $ppWeb -> newFindRequest(cWeb_zeiterfassung_Kunde::webLayout);
		$subcommand[4] -> addFindCriterion('cknd_app_Auftraege::s_Zeiterfassung_Flag_Valuelist', '1');
		$subcommand[4] -> addFindCriterion('cknd_app_Auftraege::f1_FKey_Projekt', '=');
		$subcommand[4] -> setOmit(false);
		$command -> add(5, $subcommand[4]);

		$command -> addSortRule('f3_adr_Titel_Vorname_Name', 1, FILEMAKER_SORT_ASCEND);

		$result = $command -> execute();

		$EMPLOYERs = array();
		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$EMPLOYERs[] = new cWeb_zeiterfassung_Kunde($ppWeb, $record);
		}
		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<Records count="%s">', count($EMPLOYERs));
		foreach ($EMPLOYERs as $EMPLOYER) {
			printf('<record');
			printf(' guid="%s"', $EMPLOYER -> GUID());
			printf(' NrP="%s"', $EMPLOYER -> NrP());
			printf(' KundeNr="%s"', $EMPLOYER -> KundeNr());
			printf(' Titel="%s"', $EMPLOYER -> Titel());
			printf(' />');
		}
		printf('</Records>');

		break;

	case 'getLayout' :
		if (!isset($_GET['member']))
			exit ;
		;
		$token = $_GET['member'];
		$command = $ppWeb -> newFindCommand(cUser::webLayout);
		$command -> addFindCriterion('user_app_Mitarbeiter::f1_GUID', "==" . $_GET['member']);
		$result = $command -> execute();

		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$sum = new cUser($ppWeb, $record);
		}

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<Sum');
		printf(' Layout="%s"', $sum -> LayoutTyp());
		printf(' />');

		break;
	case 'setAusfall' :
		if (!isset($_GET['member']))
			exit ;

		$command = $ppWeb -> newAddCommand(cWeb_stempeluhr_Arbeitszeitmodell_Sozial_Ausfall::webLayout);
		$result = $command -> execute();

		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();

			foreach ($records as $record) {
				$sum = new cWeb_stempeluhr_Arbeitszeitmodell_Sozial_Ausfall($ppWeb, $record);
				$record -> setField('f1_Bezeichnung', $_GET['notice']);
				$record -> setField('f1_Datum_Von', $_GET['date_from']);
				$record -> setField('f1_Datum_Bis', $_GET['date_to']);
				$record -> setField('f1_Typ', $_GET['typ']);
				$record -> setField('f1_FKey_Mitarbeiter', $_GET['member']);
				//$record->setField('f1_Dauer_d',$_GET['duration']);
				$record -> setField('s_Flag_WEBZeit_Genehmigt_Timestamp', $_GET['timestamp']);
				$record -> setField('f1_DurchWartungBerechnen_Task', '1');
				$record -> commit();
			}
		} else {
			//die('error: '. $result->getErrorString());
		}
		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<Sum');
		printf(' RecID="%s"', $sum -> RecID());
		printf(' Loeschen="%s"', $sum -> Loeschen());
		printf(' Genehmigt="%s"', $sum -> Genehmigt_timestamp());
		printf(' />');

		break;

	case 'getAusfall' :
		if (!isset($_GET['member']))
			exit ;

		$command = $ppWeb -> newFindCommand(cWeb_stempeluhr_Arbeitszeitmodell_Sozial_Ausfall::webLayout);
		$command -> addFindCriterion('f3_Jahr', "==" . $_GET['jahr']);
		$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $_GET['member']);
		$command -> addSortRule('f1_Datum_Von', 1, FILEMAKER_SORT_ASCEND);
		$result = $command -> execute();

		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$RECORDs[] = new cWeb_stempeluhr_Arbeitszeitmodell_Sozial_Ausfall($ppWeb, $record);
		}

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<Records count="%s">', count($RECORDs));
		foreach ($RECORDs as $record) {

			$DatumVon = str_replace('/', '.', $record -> DatumVon());
			$DatumBis = str_replace('/', '.', $record -> DatumBis());

			printf('<record');
			printf(' Bezeichnung="%s"', $record -> Bezeichnung());
			printf(' Datum_Von="%s"', $DatumVon);
			printf(' Datum_Bis="%s"', $DatumBis);
			printf(' Dauer="%s"', $record -> Dauer());
			printf(' RecID="%s"', $record -> RecID());
			printf(' Typ="%s"', $record -> Typ());
			printf(' Wartung="%s"', $record -> Wartung());
			printf(' Loeschen="%s"', $record -> Loeschen());
			printf(' Genehmigt="%s"', $record -> Genehmigt_timestamp());
			printf(' />');
		}
		printf('</Records>');

		break;

	case 'deleteAusfall' :
		if (!isset($_GET['recid']))
			exit ;

		if (isset($_GET['recid'])) {
			$Ausfall = new cWeb_stempeluhr_Arbeitszeitmodell_Sozial_Ausfall($ppWeb);
			if ($Ausfall -> openRecID($_GET['recid']))/*die('error: '. $result->getErrorString());*/
				;
		} else {
			//die('error: no matching overload');
		}

		$edit = false;
		if (isset($_GET['recid'])) { $Ausfall -> Wartung("9");
			$edit = true;
		}

		if ($edit == true)
			if (FileMaker::IsError($result = $Ausfall -> commit()))/*die($result->getErrorString());*/
				$Ausfall -> commit();

		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<Loeschen');
		printf(' loeschen="%s"', $Ausfall -> Wartung());

		printf(' />');

		break;

	case 'getYear' :
		if (!isset($_GET['member']))
			exit ;
		$command = $ppWeb -> newFindCommand(cUeberstunden::webLayout);
		$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $_GET['member']);
		$command -> addFindCriterion('s_Jahr_flag', "==" . "1");
		$command -> addFindCriterion('f1_Jahr', ">=" . $_GET['jahr']);
		$command -> addSortRule('f1_Jahr', 1, FILEMAKER_SORT_ASCEND);
		$result = $command -> execute();

		if (!FileMaker::IsError($result)) {
			$records = $result -> getRecords();
			foreach ($records as $record)
				$RECORDs[] = new cUeberstunden($ppWeb, $record);
		}
		header('Content-Type: application/xml');
		printf('<?xml version="1.0" encoding="utf-8"?>');
		printf('<Records count="%s">', count($RECORDs));
		foreach ($RECORDs as $record) {
			printf('<record');
			printf(' Jahr="%s"', $record -> Jahr());
			printf(' />');
		}
		printf('</Records>');

		break;
	default :
}
?>