//#####################################STEMPELUHR##################################

//Mitarbeiterauswertung
function GetSum_ze() {

	//Initialisieren der Membervariable
	var member = document.getElementById("query_token").value;
	// initialisieren des Datums
	var date = document.getElementById("query_date").value;
	var date_split = date.split(".");
	date = date_split[1] + "." + date_split[0] + "." + date_split[2];

	var xml = $.ajax({
		url : 'port.php',
		data : {
			port : 'GetSum_ze',
			date : date,
			member : member
		},
		async : false,
		dataType : 'xml'
	}).responseXML;

	var xml_array = new Array();
	xml_array['hours'] = $('Sum', xml).attr('hours_ze');

	if (xml_array['hours'].indexOf(",") >= 0) {
		if (xml_array['hours'].charAt(xml_array['hours'].indexOf(",") + 2) == "") {
			xml_array['hours'] = xml_array['hours'] + "0";
		}
		if (xml_array['hours'].charAt(0) == ",") {
			xml_array['hours'] = "0" + xml_array['hours'];
		}
	}

	//var alle = document.getElementById("zeiterfassung_sum").firstChild.length();
	document.getElementById("zeiterfassung_sum").firstChild.deleteData(0, 9);
	if (xml_array['hours'] != "") {
		document.getElementById("zeiterfassung_sum").firstChild.insertData(0, xml_array['hours'] + " h");
	}
}

// Tagesauswertung
function GetSum(param) {
	if (vertrauensarbeitszeit_flag) {
		GetSumShare();
		return;
	}
	//Initialisieren der Membervariable
	var member = document.getElementById("query_token").value;
	// initialisieren des Datums
	//Datum Vorbereibten
	var date = document.getElementById("query_date").value;

	/*
	 if(global_language !="eng"){
	 var date_split = new Array();
	 date_split = date.split ('.');
	 var date_day = date_split[0];
	 var date_month = date_split[1];
	 var date_year = date_split[2];
	 date = date_month + '/' + date_day + '/' + date_year;
	 }
	 */

	var date_split = new Array();
	date_split = date.split('.');
	var date_day = date_split[0];
	var date_month = date_split[1];
	var date_year = date_split[2];
	date = date_month + '/' + date_day + '/' + date_year;

	var xml = $.ajax({
		url : 'port.php',
		data : {
			port : 'GetMitarb',
			member : member
		},
		async : false,
		dataType : 'xml'
	}).responseXML;
	FKeyKalender = $('Mitarb', xml).attr('Calender');

	if (param == 2 || param == 3) {
		global_ProjektZeit = GetSum_ProjektZeit(member, date);
		global_ArbeitsZeit = GetSum_ArbeitsZeit(member, date);

	}

	if (param == 1 || param == 3) {
		global_ArbeitsZeitSoll = GetDayAnalysis(date, member);
	}

	HourCalculation(global_ArbeitsZeit, global_ProjektZeit, global_ArbeitsZeitSoll);

	if (param == 1 || param == 3) {
		GetYearAnalysis(date, member);
	}

}

function GetSumShare() {
	var sumPercent = 0;
	$('.timeDuration').each(function() {
		var percent = $(this).attr("percent");
		sumPercent += parseFloat(percent);
	});
	sumPercent = sumPercent.toFixed(2);
	$("#arbeitszeit").html((sumPercent * 100) + " %");
}
//Arbeitszeitauswertung
function Get_ArbeitsZeit_Vertrauensarbeitszeit(member,date) {
	var xml = $.ajax({
		url : 'port.php',
		data : {
			port : 'Vertrauensarbeitszeit',
			member : member,
			date : date
		},
		async : false,
		dataType : 'json'
	}).responseText;
	
	var jsonResult = JSON.parse(xml);
	if(jsonResult.length == 0)return;
	if(jsonResult[0].Vertrauensarbeitszeit == 1){
		vertrauensarbeitszeit_flag = true;
	}


}
//Arbeitszeitauswertung
function GetSum_ArbeitsZeit(member, date) {
	if (vertrauensarbeitszeit_flag) {
		return;
	}
	var xml = $.ajax({
		url : 'port.php',
		data : {
			port : 'GetSum_ArbeitZeit',
			date : date,
			member : member
		},
		async : false,
		dataType : 'xml'
	}).responseXML;
	var xml_array = new Array();
	xml_array['hours'] = $('Stunden', xml).attr('sum_std');
	//alert(xml_array['hours']);
	if (xml_array['hours'] == "" || typeof (xml_array['hours']) == 'undefined' || xml_array['hours'] == null) {
		xml_array['hours'] = '0';
	}

	// Bei ,* Zahl eine 0 vorher anbringen
	if (xml_array['hours'].substr(0, 1) == ',') {
		xml_array['hours'] = '0' + xml_array['hours'];
	}
	//stundensatz holen
	var gethour = xml_array['hours'];

	//Kommas durch punkte ersetzen wegen parseFloat
	gethour = gethour.replace(",", ".");
	//Wert in Float umwandeln
	gethour = parseFloat(gethour);
	//auf 2 Kommastellen immer runden
	gethour = gethour.toFixed(2);
	//Punkte wieder durch Kommas ersetzen
	gethour = gethour.replace(".", ",");

	//Schreiben des Summenfeldes
	if (xml_array['hours'] != "" || typeof (xml_array['hours']) !== 'undefined' || xml_array['hours'] != null) {
		// document.getElementById("stempeluhr_sum").firstChild.deleteData (0, 9);
		// document.getElementById("stempeluhr_sum").firstChild.insertData(0,gethour + " h");
		document.getElementById("arbeitszeit").firstChild.deleteData(0, 9);
		document.getElementById("arbeitszeit").firstChild.insertData(0, gethour + " h");
	}

	return (xml_array['hours']);
}

function GetSum_ProjektZeit(member, date) {
	if (vertrauensarbeitszeit_flag == true) {
		return;
	}
	var xml = $.ajax({
		url : 'port.php',
		data : {
			port : 'GetSum_ProjektZeit',
			date : date,
			member : member
		},
		async : false,
		dataType : 'xml'
	}).responseXML;
	var xml_array = new Array();

	xml_array['hours'] = $('Stunden', xml).attr('std');
	if (xml_array['hours'] == "" || typeof (xml_array['hours']) == 'undefined' || xml_array['hours'] == null) {
		xml_array['hours'] = '0';
	}

	xml_array['hours'] = xml_array['hours'].replace(",", ".");
	xml_array['hours'] = Math.round(xml_array['hours'] * 100) / 100;
	xml_array['hours'] = String(xml_array['hours']);
	xml_array['hours'] = xml_array['hours'].replace(".", ",");

	// Bei ,* Zahl eine 0 vorher anbringen
	if (xml_array['hours'].substr(0, 1) == ',') {
		xml_array['hours'] = '0' + xml_array['hours'];
	}
	//stundensatz holen
	var gethour = xml_array['hours'];
	//Kommas durch punkte ersetzen wegen parseFloat
	gethour = gethour.replace(",", ".");
	//Wert in Float umwandeln
	gethour = parseFloat(gethour);
	//auf 2 Kommastellen immer runden
	gethour = gethour.toFixed(2);
	//Punkte wieder durch Kommas ersetzen
	gethour = gethour.replace(".", ",");
	//Schreiben des Summenfeldes
	if (xml_array['hours'] != "" && typeof (xml_array['hours']) !== 'undefined' && xml_array['hours'] != null) {
		//document.getElementById("zeiterfassung_sum").firstChild.deleteData (0, 9);
		//document.getElementById("zeiterfassung_sum").firstChild.insertData(0,gethour + " h");
		document.getElementById("projektzeit").firstChild.deleteData(0, 9);
		document.getElementById("projektzeit").firstChild.insertData(0, gethour + " h");
		return (xml_array['hours']);
	}

	return (xml_array['hours']);
}

//Tagesauswertung
function GetDayAnalysis(date, member) {

	var xml = $.ajax({
		url : 'port.php',
		data : {
			port : 'GetDayAnalysis',
			date : date,
			member : member
		},
		async : false,
		dataType : 'xml'
	}).responseXML;
	var count = $('Records', xml).attr('count');

	// Berechnen der Tagesstunden
	var ArbeitsStd_Res;
	var ArbeitsStd_alt = 0;
	var tmp1;
	var tmp2;
	var ergebnis;

	for (var i = 0; i < count; i++) {
		ArbeitsStd_Res = $('record:eq(' + i + ')', xml).attr('ArbeitsStd_Res');

		//Kommas durch punkte ersetzen wegen parseFloat
		tmp1 = ArbeitsStd_Res.replace(",", ".");

		//Wert in Float umwandeln
		tmp1 = parseFloat(tmp1);

		//auf 2 Kommastellen immer runden
		tmp1 = tmp1.toFixed(2);

		if (tmp1 < 0) {
			tmp1 = tmp1 * (-1);
			ArbeitsStd_alt = parseFloat(ArbeitsStd_alt - tmp1);
		} else if (tmp1 == "0.00" || tmp1 == 0) {
			ArbeitsStd_alt = parseFloat(ArbeitsStd_alt);
		} else {
			ArbeitsStd_alt = parseFloat(ArbeitsStd_alt + tmp1);
		}
		//alert ("ArbeitsStd_Res: " + ArbeitsStd_Res + "\n" + "tmp1: " + tmp1 + "\n" + "ArbeitsStd_alt: " + ArbeitsStd_alt);
	}

	//Ausgabe formatieren
	
	ergebnis = ArbeitsStd_alt.toFixed(2);
	ergebnis = ergebnis.replace(".", ",");

	if (vertrauensarbeitszeit_flag == false) {
		document.getElementById("tagessoll").firstChild.deleteData(0, 9);
		if (ergebnis != "") {
			document.getElementById("tagessoll").firstChild.insertData(0, ergebnis + " h");
		}

	}

	//return Ergebnis
	return (ergebnis);

}

function HourCalculation(ArbeitsZeit, ProjektZeit, ArbeitsZeitSoll) {
	if (vertrauensarbeitszeit_flag == true) {
		return;
	}
	var ArbeitsZeit = parseFloat(ArbeitsZeit.replace(",", "."));
	var ProjektZeit = parseFloat(ProjektZeit.replace(",", "."));
	var ArbeitsZeitSoll = parseFloat(ArbeitsZeitSoll.replace(",", "."));

	var differenz = Math.round((ProjektZeit - ArbeitsZeit) * 100) / 100;
	//if (ArbeitsZeit == 0){differenz = '';}

	var ueberstunden = Math.round((ProjektZeit - ArbeitsZeitSoll) * 100) / 100;

	var di_text = parseFloat(differenz);
	di_text = di_text.toFixed(2);

	var di_text2 = di_text.replace(".", ",");

	if (ueberstunden == 0) {
		ueberstunden = '0';
	} else {
		var sollUe_text = parseFloat(ueberstunden);
		sollUe_text = sollUe_text.toFixed(2);
		var sollUe_text2 = sollUe_text.replace(".", ",");
	}

	if (!sollUe_text2) {
		sollUe_text2 = '0,00';
	}
	if (monatsanzeige_flag != "1") {
		document.getElementById("ueberstunden").firstChild.deleteData(0, 9);
		document.getElementById("ueberstunden").firstChild.insertData(0, sollUe_text2 + " h");
	}
	document.getElementById("differenz").firstChild.deleteData(0, 9);
	if (differenz != "") {
		document.getElementById("differenz").firstChild.insertData(0, di_text2 + " h");
	} else {
		document.getElementById("differenz").firstChild.insertData(0, "0,00 h");
	}

}

function GetYearAnalysis(date, member) {

	var xml = $.ajax({
		url : 'port.php',
		data : {
			port : 'GetMitarbUeberstunden',
			date : date,
			member : member
		},
		async : false,
		dataType : 'xml'
	}).responseXML;

	var xml_array = new Array();
	xml_array['UeberstundenJahr'] = $('Sum', xml).attr('UeberstundenJahr');
	xml_array['toleranz'] = $('Sum', xml).attr('ueberstdtoleranz');
	xml_array['ueberstunden'] = $('Sum', xml).attr('ueberstunden');
	xml_array['Resturlaub'] = $('Sum', xml).attr('Resturlaub');
	if ( typeof (xml_array['UeberstundenJahr']) == 'undefined') {
		var testueberstundenJahr = "0";
		xml_array['UeberstundenJahr'] = "0";
	} else {
		var testueberstundenJahr = xml_array['UeberstundenJahr'];
		//0 anh�ngen bei werten zwischen 0 und 1
		if (testueberstundenJahr.charAt(0) == ",") {
			xml_array['UeberstundenJahr'] = "0" + testueberstundenJahr;
		}

		//Runden

		if (xml_array['UeberstundenJahr'].indexOf(",") >= 1) {
			xml_array['UeberstundenJahr'] = xml_array['UeberstundenJahr'].replace(",", ".");
		}
		xml_array['UeberstundenJahr'] = Math.round(xml_array['UeberstundenJahr'] * 100) / 100;
		xml_array['UeberstundenJahr'] = String(xml_array['UeberstundenJahr']);
		if (xml_array['UeberstundenJahr'].indexOf(".") >= 1) {
			xml_array['UeberstundenJahr'] = xml_array['UeberstundenJahr'].replace(".", ",");
		}
	}
	if ( typeof (xml_array['ueberstunden']) == 'undefined') {
		var testueberstunden = "0";
		xml_array['ueberstunden'] = "0";
	} else {
		var testueberstunden = xml_array['ueberstunden'];
		//0 anh�ngen bei werten zwischen 0 und 1
		if (testueberstunden.charAt(0) == ",") {
			xml_array['ueberstunden'] = "0" + testueberstunden;
		}

		//Runden
		if (xml_array['ueberstunden'].indexOf(",") >= 1) {
			xml_array['ueberstunden'] = xml_array['ueberstunden'].replace(",", ".");
		}
		xml_array['ueberstunden'] = Math.round(xml_array['ueberstunden'] * 100) / 100;
		xml_array['ueberstunden'] = String(xml_array['ueberstunden']);
		if (xml_array['ueberstunden'].indexOf(".") >= 1) {
			xml_array['ueberstunden'] = xml_array['ueberstunden'].replace(".", ",");
		}

		if (xml_array['ueberstunden'].indexOf(",") >= 1) {
			var stunden = parseFloat(xml_array['ueberstunden'].replace(",", "."));
		} else {
			var stunden = 0;
		}
	}

	var toleranz = xml_array['toleranz'];
	//leeren Toleranzwert mit 0 initialisieren
	if (toleranz == "" || typeof (toleranz) == 'undefined') {
		toleranz = "0";
	}

	//Kommas durch punkte ersetzen wegen parseFloat
	toleranz = toleranz.replace(",", ".");
	//Wert in Float umwandeln
	toleranz = parseFloat(toleranz);
	//auf 2 Kommastellen immer runden
	toleranz = toleranz.toFixed(2);
	if (!isNaN(toleranz)) {
		xml_array['erg'] = stunden + toleranz;
	} else {
		xml_array['erg'] = stunden;
	}

	if (xml_array['erg'] == 0) {
		xml_array['erg'] = '0';
	}

	if (isNaN(xml_array['erg'])) {
		xml_array['erg'] = '0';
	}

	xml_array['ueberstunden'] = xml_array['ueberstunden'].replace(".", ",");

	xml_array['erg'] = String(xml_array['erg']);
	xml_array['erg'] = xml_array['erg'].replace(".", ",");
	//�berstunde nsatz holen
	var ueberstunden = xml_array['ueberstunden'];

	//Kommas durch punkte ersetzen wegen parseFloat
	ueberstunden = ueberstunden.replace(",", ".");

	//Wert in Float umwandeln

	ueberstunden = parseFloat(ueberstunden);
	var ueberstundenohne = ueberstunden;
	if (ueberstunden >= 0) {
		ueberstundenohne = ueberstunden + parseFloat(toleranz);
	}

	//auf 2 Kommastellen immer runden
	ueberstunden = ueberstunden.toFixed(2);
	ueberstundenohne = ueberstundenohne.toFixed(2);
	//Punkte wieder durch Kommas ersetzen
	ueberstunden = ueberstunden.replace(".", ",");
	ueberstundenohne = ueberstundenohne.replace(".", ",");
	//Ueberstunden im Jahr holen
	var UeberstundenJahr = xml_array['UeberstundenJahr'];
	//Kommas durch punkte ersetzen wegen parseFloat
	UeberstundenJahr = UeberstundenJahr.replace(",", ".");
	//Wert in Float umwandeln
	UeberstundenJahr = parseFloat(UeberstundenJahr);
	//auf 2 Kommastellen immer runden
	UeberstundenJahr = UeberstundenJahr.toFixed(2);
	//Punkte wieder durch Kommas ersetzen
	UeberstundenJahr = UeberstundenJahr.replace(".", ",");

	//Resturlaub holen
	var Resturlaub = xml_array['Resturlaub'];

	if ( typeof (xml_array['Resturlaub']) == 'undefined') {
		Resturlaub = "0,00";
		xml_array['Resturlaub'] = 0;
	} else {
		//Kommas durch punkte ersetzen wegen parseFloat
		Resturlaub = Resturlaub.replace(",", ".");
		//Wert in Float umwandeln
		Resturlaub = parseFloat(Resturlaub);
		//auf 2 Kommastellen immer runden
		Resturlaub = Resturlaub.toFixed(2);
		//Punkte wieder durch Kommas ersetzen
		Resturlaub = Resturlaub.replace(".", ",");
	}

	//Schreiben des Summenfeldes
	if (monatsanzeige_flag != "1") {
		if (xml_array['ueberstunden'] != "" && typeof (xml_array['ueberstunden']) !== 'undefined' && xml_array['ueberstunden'] != null) {
			var anzahlZeichenMonat = document.getElementById("ueberstunden_monat_ohne").firstChild.nodeValue.length;
			document.getElementById("ueberstunden_monat_ohne").firstChild.deleteData(0, anzahlZeichenMonat);
			document.getElementById("ueberstunden_monat_ohne").firstChild.insertData(0, ueberstundenohne + " h");
		}

		if (xml_array['ueberstunden'] != "" && typeof (xml_array['ueberstunden']) !== 'undefined' && xml_array['ueberstunden'] != null) {
			var anzahlZeichenMonat = document.getElementById("ueberstunden_monat").firstChild.nodeValue.length;
			document.getElementById("ueberstunden_monat").firstChild.deleteData(0, anzahlZeichenMonat);
			document.getElementById("ueberstunden_monat").firstChild.insertData(0, ueberstunden + " h");
		}

		if (xml_array['ueberstunden'] != "" && typeof (xml_array['ueberstunden']) !== 'undefined' && xml_array['ueberstunden'] != null) {
			var anzahlZeichenJahr = document.getElementById("ueberstunden_jahr").firstChild.nodeValue.length;
			document.getElementById("ueberstunden_jahr").firstChild.deleteData(0, anzahlZeichenJahr);
			document.getElementById("ueberstunden_jahr").firstChild.insertData(0, UeberstundenJahr + " h");

		}

		if (xml_array['Resturlaub'] != "" && typeof (xml_array['Resturlaub']) !== 'undefined' && xml_array['Resturlaub'] != null) {
			document.getElementById("resturlaub").firstChild.deleteData(0, 9);
			document.getElementById("resturlaub").firstChild.insertData(0, Resturlaub + " d");
		}
	}
}