<?php
require_once ('config.php');
require_once ('classes.php');
require_once ('FileMaker.php');
error_reporting(E_CONFIG);
session_start();

// iserror: FM schnittstellen fehler?
function iserror($result) {
	if (FileMaker::IsError($result) and !$result -> isValidationError()) {
		return true;
	}
	return false;
}

// errecho: fehlerausgabe
function printerror($msg) {
	echo "<center id=\"error\">" . $msg . "</center>\n";
	exit ;
}

function openDB() {
	$ppWeb = new FileMaker();
	$ppWeb -> setProperty('database', DB_HOST_FILE);
	$ppWeb -> setProperty('hostspec', DB_HOST_SPEC);
	$ppWeb -> setProperty('username', DB_USER_NAME);
	$ppWeb -> setProperty('password', DB_USER_PASS);
	return $ppWeb;
}

function vertrauensarbeitszeit($member, $date) {
	$ppWeb = openDB();
	$command = $ppWeb -> newFindCommand(cGetWeb_stempeluhr_Arbeitszeitmodell_Arbeitstag::webLayout);
	$command -> addFindCriterion('f1_FKey_Mitarbeiter', "==" . $member);
	$command -> addFindCriterion('f1_Datum', "==" . $date);
	$command -> addFindCriterion('f1_Typ', "1");
	$command -> addFindCriterion('s_Arbeitstag_Flag', "1");

	$result = $command -> execute();

	$DAYs = array();
	if (!FileMaker::IsError($result)) {
		$records = $result -> getRecords();
		foreach ($records as $record)
			$DAYs[] = new cGetWeb_stempeluhr_Arbeitszeitmodell_Arbeitstag($ppWeb, $record);
	}
	$return;
	$result = array();
	foreach ($DAYs as $DAY) {
		$datum = str_replace('/', '.', $DAY -> Date());
		$json = array('Typ' => $DAY -> Typ(), 'Bezeichnung' => $DAY -> Bezeichnung(), 'Vertrauensarbeitszeit' => $DAY -> Vertrauensarbeitszeit(), 'Date' => $datum);
		array_push($result, $json);
		if($DAY -> Vertrauensarbeitszeit() == 1){
			$return = 1;
		}
		
	}
	return $return;
}
?>